﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using Infragistics.Controls.Editors;
using Infragistics.Documents;
using Infragistics.Documents.Parsing;

namespace XamSyntaxEditorInvalidVars
{
    public class MainWindowViewModel : ViewModelBase
    {
        public MainWindowViewModel()
        {
        }
        
        private string _selectedListBoxItem;
        public string SelectedListBoxItem
        {
            get
            {
                return _selectedListBoxItem;
            }
            set
            {
                _selectedListBoxItem = value;
                RaisePropertyChanged(() => SelectedListBoxItem);
            }
        }

        private List<string> _jobVariables;
        public List<string> JobVariables
        {
            get
            {
                if (_jobVariables == null)
                {
                    _jobVariables = new List<string>()
                    {
                        "LASTRUN",
                        "LASTRUN.YYYY",
                        "LASTRUN.YY",
                        "LASTRUN.MMMM",
                        "LASTRUN.MMM",
                        "LASTRUN.MM",
                        "LASTRUN.M",
                        "LASTRUN.DDDD",
                        "LASTRUN.DDD",
                        "LASTRUN.DD",
                        "LASTRUN.D",
                        "LASTRUN.HH",
                        "LASTRUN.NN",
                        "LASTRUN.SS",
                    };

                }
                return _jobVariables;
            }
        }

        private ClassificationAppearanceMap _classificationAppearanceMap;

        public ClassificationAppearanceMap ClassificationAppearanceMap
        {
            get { return _classificationAppearanceMap; }
            set
            {
                _classificationAppearanceMap = value;
                RaisePropertyChanged(() => ClassificationAppearanceMap);
            }
        }

        private TextDocument _textDocument;

        public TextDocument TextDocument
        {
            get
            {
                if (_textDocument == null)
                {
                    _textDocument = new TextDocument();
                    _textDocument.AutoCasingMode = TextDocumentAutoCasingMode.None;
                    _textDocument.Language = TSqlLanguage.Instance;
                    _textDocument.InitializeText("\n\n\n\n\n Select * from Orders \n\n\n\n\n");

                }

                return _textDocument;

            }
            set
            {
                _textDocument = value;
                RaisePropertyChanged(() => TextDocument);
            }

        }

    }
}
